<?php



	require('config.php');



	function state($stat,$msg){

		echo json_encode(array(

			'stat' => $stat,

			'msg' => $msg

		),JSON_UNESCAPED_UNICODE);

	}

	function userin($userkey){

		$userarray = adduser($userkey);

		//广播给当前用户进入的信息给其他人。

			$keys = userkeys($userarray);

			$keys = preg_replace('/(\s)?'.$userkey.'(\s)?/',' ',$keys);

			$fid = $userarray[$userkey]['fid'];

			$msgarray = array(

					'fid' => $fid,

					'nickname' => $userarray[$userkey]['nickname'],

					'num' => count($userarray),

					'type' => 'userin',

					'date' => time()

				);

			WSPushMsgs($keys, json_encode($msgarray,true));

		//广播进入的用户房间信息

			$ul = array();

			foreach($userarray as $uk => $u){

				$ul[$userarray[$uk]['fid']] = $userarray[$uk]['nickname'];

			}

			$ul = array(

				'fid' => $fid,

				'key' => $userkey,

				'type' => 'in',

				'users' => $ul

			);

			WSPushMsgs($userkey, json_encode($ul,true));

	}



	function userout($userkey){

		$userarray = deleteuser($userkey);

		if(array_key_exists($userkey,$userarray)){

			$msgarray = array(

						'fid' => $userarray[$userkey]['fid'],

						'type' => 'userout',

						'nickname' => preg_replace('/\.[^.]+$/','.*',$userarray[$userkey]['nickname']),

						'date' => time()

					);

			$keys = userkeys($userarray);



			WSPushMsgs($keys, json_encode($msgarray,true)); //单个用户打开两个窗口会有两次退出

		}

		else state(0,'用户不存在');

	}



	function deleteuser($k){

		$r = $userarray = userlist();

		unset($userarray[$k]);

		if(count($userarray) == 0) unlink(USER_JSON_PATH);

		else putfile(USER_JSON_PATH,$userarray);

		return $r;

	}



	function heartbeat($userkey){

		$ul = array(

			'type' => 'severbeat'

		);

		if(WSPushMsgs($userkey, json_encode($ul,true))) state(0,'返回心跳失败');

		else state(1,'请求成功');

	}



	function userlist(){

		if(is_file(USER_JSON_PATH)) $json = file_GET_contents(USER_JSON_PATH);

		else return [];

		return json_decode($json,JSON_UNESCAPED_UNICODE);

	}



	function adduser($userkey){

		$userarray = userlist();

		if(!isset($userarray[$userkey])){

			$frontuid = count($userarray)?(end($userarray)['fid'] + 1):1;

			$userarray[$userkey] = array(

				'fid' => $frontuid,

				'nickname' =>''

			);

			putfile(USER_JSON_PATH,$userarray);

			return $userarray;

		}

	}



	function userkeys($a){

		$userkey = array_keys($a);

		$keys = implode(' ',$userkey);

		return $keys;

	}



	function putfile($path,$array){

		file_put_contents($path,json_encode($array));

	}



	function msglist(){

		if(is_file(MSG_JSON_PATH)) $json = file_GET_contents(MSG_JSON_PATH);

		else return [];

		return json_decode($json,JSON_UNESCAPED_UNICODE);

	}



	function formattedmsglist(){

		$arr = is_file(MSG_JSON_PATH)?json_decode(file_GET_contents(MSG_JSON_PATH),JSON_UNESCAPED_UNICODE):[];

		$msgarr = array();

		if(BBCODE_ENABLE){

			require "bbcode.php";

			$bbcode = new BBCode;

		}

		if(count($arr)){

			foreach($arr as $i){

				$msgarr[] = array(

					'mid' => $i['mid'],

					'date' => $i['date'],

					'nickname' => preg_replace('/\.[^.]+$/','.*',$i['nickname']),

					'msg' => BBCODE_ENABLE?$bbcode->toHTML($i['msg']):$i['msg']

				);

			};

			return $msgarr;

		}

		else return [];

	}

	function setnicknameannouncement($fid,$userarray,$userkey,$nickname,$prevname){//广播昵称更改

		$keys = userkeys($userarray);

		$msgarray = array(

					'fid' => $fid,

					'nickname' => preg_replace('/\.[^.]+$/','.*',$nickname),

					'prevname' => preg_replace('/\.[^.]+$/','.*',$prevname),

					'type' => 'rename',

					'date' => time()

				);

		return WSPushMsgs($keys, json_encode($msgarray));

	}

	function setnickname($userkey,$nickname){//设置昵称

		$a = userlist();

		$nn = $a[$userkey]['nickname'];

		if($nickname == '') $nickname = $_SERVER['REMOTE_ADDR'];

		if($nn == '') $nn = $_SERVER['REMOTE_ADDR'];

		if(USER_NAME_CHANGE){

			if(setnicknameannouncement($a[$userkey]['fid'],$a,$userkey,$nickname,$nn)){

				state(1,'设置昵称失败');

			}

			else{

				$a[$userkey]['nickname'] = $nickname;

				putfile(USER_JSON_PATH,$a);

				state(1,'设置昵称成功');

			}

		}

		else state(0,'不允许更改昵称');

	}



	function sendmsg($userkey,$msg){//广播发送的消息

		if(BBCODE_ENABLE){

			require "bbcode.php";

			$bbcode = new BBCode;

			$msg = $bbcode->toHTML($msg);

		}

		$userarray = userlist();



		if(array_key_exists($userkey,$userarray)){

				$keys = userkeys($userarray);

				$mid = count(msglist())?(end(msglist())['mid'] + 1):1;

				if(!empty($userarray[$userkey]['nickname'])) $nickname = $userarray[$userkey]['nickname'];

				else $nickname = $_SERVER['REMOTE_ADDR'];

				$msgarray = array(

							'mid' => $mid,

							'fid' => $userarray[$userkey]['fid'],

							'nickname' => preg_replace('/\.[^.]+$/','.*',$nickname),

							'type' => 'msg',

							'msg' =>  $msg,

							'date' => time()

						);

				if(!WSPushMsgs($keys, json_encode($msgarray))){

					if(SAVE_MSG) addmsg($msg,$userkey,$nickname);//广播成功后 添加本地记录

					echo state(1,'消息发送成功');

				}

				else state(0,'广播消息失败');

		}

		else state(0,'用户KEY不存在');

	}



	function addmsg($msg,$userkey,$nickname){//添加消息到文件

		$msgarray =  msglist();

		$mid = count($msgarray)?(end($msgarray)['mid'] + 1):1;

		$msgarray[$mid] = array(

			'mid' => $mid,

			'msg' => $msg,

			'nickname' => $nickname,

			'date' => time(),

			'userkey' => $userkey,

			'ip' => $_SERVER['REMOTE_ADDR']

		);

		putfile(MSG_JSON_PATH,$msgarray);

		return $msgarray;

	}



	function revokeannouncement($mid,$userkey,$nickname){//广播消息撤回

		$userarray = userlist();

		$keys = userkeys($userarray);

		$msgarray = array(

					'mid' => (int) $mid,

					'fid' => $userarray[$userkey]['fid'],

					'nickname' => preg_replace('/\.[^.]+$/','.*',$nickname),

					'type' => 'revoke',

					'date' => time()

				);



		$stat = WSPushMsgs($keys, json_encode($msgarray));

		return $stat;

	}



	function revoke($mid,$userkey){//撤回消息

		if(!MSG_REVOKE){

			state(0,'不允许撤回消息');

			return false;

		}



			$msgarray = msglist();

			$nickname = $msgarray[$mid]['nickname'];

		if($msgarray[$mid]['userkey'] == $userkey){

			unset($msgarray[$mid]);

			if(!revokeannouncement($mid,$userkey,$nickname)){

				putfile(MSG_JSON_PATH,$msgarray);

				state(1,'撤回成功');

			}

			else state(0,'撤回失败');

		}

		else state(0,'未持有该评论ID');

	}



?>